/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 181 by dpavlin, Tue Mar 16 17:39:28 2010 UTC revision 234 by dpavlin, Sat Jan 22 16:07:46 2011 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /bin/sh
2    ### BEGIN INIT INFO
3    # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15  # lxc-watchdog.sh  # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
 #  
 # Dobrica Pavlinusic <dpavlin@rot13.org> 2010-03-15  
 #  
 # this script can be used to start/stop Linux containers  
 # using clever inotify hack to monitor halt/reboot from  
 # Tony Risinger posted to lxc-users mailing list  
16  #  #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 lxc_status() {  
         lxc-ls -1 | sort -u | xargs -i lxc-info -n {}  
 }  
27    
28  lxc_exists() {  lxc_exists() {
29          name=$1          name=$1
# Line 29  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //' ) | \
52            sed -e 's/ *//g' -e 's/\/.*$//'
53    }
54    
55    lxc_status() {
56            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
57                    boot="-"
58                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
59                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
60            done ) | column -t
61  }  }
62    
63    
# Line 37  cleanup_init_scripts() { Line 65  cleanup_init_scripts() {
65          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
66    
67          ls \          ls \
68                    $rootfs/etc/rc?.d/*checkroot* \
69                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
70                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
71                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
72                    $rootfs/etc/rc?.d/*udev* \
73          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
74    
75            echo $1 > $rootfs/etc/hostname
76            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
77  }  }
78    
79    
80  setup_inittab() {  setup_inittab() {
81          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
82            remove=$2
83            add=$3
84    
85          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
86          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
87          powerfail="pw::powerfail:/sbin/init 0"          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
88          if ! grep "$powerfail" ${inittab} >/dev/null ; then                  grep -v "$remove" ${inittab} > ${inittab}.new
89                  grep -v ::power ${inittab} > ${inittab}.new                  echo $add >> ${inittab}.new
                 echo $powerfail >> ${inittab}.new  
90                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
91                  echo "$initab modified"                  echo "$inittab modified with $add"
92          fi          fi
93    }
94    
95    
96    lxc_log() {
97            echo `date +%Y-%m-%dT%H:%M:%S` $*
98  }  }
99    
100    
101  lxc_stop() {  lxc_kill() {
102          name=$1          name=$1
103            sig=$2
104    
105          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
106          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
107                  lxc-info -n $name                  lxc-info -n $name
108                  exit 1                  exit 1
109          fi          fi
110          echo "$name stop $init_pid"          lxc_log "$name kill $sig $init_pid"
111          /bin/kill -SIGPWR $init_pid          /bin/kill $sig $init_pid
112          lxc-wait -n $name -s STOPPED  }
113    
114    lxc_stop() {
115            lxc_log "$name stop"
116            lxc_kill $name -SIGPWR
117            lxc-wait -n $name -s STOPPED
118            lxc_log "$name stoped"
119    #       rm -f /var/lib/lxc/${name}/on_boot
120  }  }
121    
122    
123  lxc_start() {  lxc_start() {
124          name=$1          name=$1
125            rootfs=$(lxc_rootfs $1)
126    
127            if [ ! -e $rootfs ] ; then
128                    echo "ERROR $name rootfs $rootfs not found"
129                    return
130            fi
131    
132          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
133                  echo "$name start"                  lxc_log "$name start"
134                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
135                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
136                  lxc-info  -n $name                  lxc-info  -n $name
137                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
138          fi          fi
139  }  }
140    
# Line 91  name=$1 Line 143  name=$1
143  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
144    
145  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
146          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
         inotifywait -qqt 300 ${vps_utmp}  
147          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
148          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
149          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq 1 ]; then
150    
151                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
152                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
153    
154                  case $runlevel in                  case $runlevel in
155                  N*)                  N*)
156                          # nothing for new boot state                          # nothing for new boot state
157                  ;;                  ;;
158                  ??0)                  ??0)
159                          echo "$name halt"                          lxc_log "$name halt"
160                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
161                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
162                          break                          break
163                  ;;                  ;;
164                  ??6)                  ??6)
165                          echo "$name reboot";                          lxc_log "$name reboot";
166                          lxc-stop -n ${name}                          lxc-stop -n ${name}
167                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
168                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 124  while true; do Line 174  while true; do
174                  ;;                  ;;
175                  esac                  esac
176          else          else
177                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks"
178          fi          fi
179    
180            # time of 5 minutes on it JUST IN CASE...
181            inotifywait -qqt 300 ${vps_utmp}
182  done  done
183    
184  echo "${name} exited"  lxc_log "$name watchdog exited"
185    
186    }
187    
188    
189    usage() {
190            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
191            exit 3
192  }  }
193    
194    command_on_lxc() {
195    command=$1
196    shift
197    
198    echo "# $command $1"
199    
200  case "$1" in  case "$command" in
201    
202  start)  start)
203          lxc_exists $2          lxc_exists $1
204          cleanup_init_scripts $2          cleanup_init_scripts $1
205          setup_inittab $2          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
206          lxc_start $2          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
207          ( nohup $0 watchdog $2 >> /tmp/$2.log ) &          setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
208          ;;          lxc_start $1
209  stop)          # give container 5 seconds to start more than one process
210          lxc_exists $2          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
211          lxc_stop $2          ;;
212          ;;  stop|halt)
213  status)          lxc_exists $1
214          lxc_status          lxc_stop $1
215          ;;          ;;
216  reload|force-reload|restart)  reload|force-reload|restart|reboot)
217          lxc_stop $2          lxc_kill $1 -SIGINT
         lxc_start $2  
218          ;;          ;;
219  watchdog)  watchdog)
220          lxc_watchdog $2          lxc_watchdog $1
221            ;;
222    boot)
223            echo $1 > /var/lib/lxc/$1/on_boot
224            ;;
225    disable)
226            echo -n > /var/lib/lxc/$1/on_boot
227          ;;          ;;
228  *)  *)
229          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
230          ;;          ;;
231    
232  esac  esac
233    
234    }
235    
236    command=$1
237    test -z "$command" && usage
238    test "$command" = "status" && lxc_status && exit
239    shift
240    
241    if [ -z "$1" ] ; then
242            ls /var/lib/lxc/*/on_boot | while read path ; do
243                    name=`echo $path | cut -d/ -f5`
244                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
245                            command_on_lxc $command $name
246                    else
247                            echo "# skip $command $name"
248                    fi
249            done
250    else
251            while [ ! -z "$1" ] ; do
252                    command_on_lxc $command $1
253                    shift
254            done
255    fi
256    

Legend:
Removed from v.181  
changed lines
  Added in v.234

  ViewVC Help
Powered by ViewVC 1.1.26